#ifndef __CONSTANTS_H__
#define __CONSTANTS_H__

#define CT_OK						0x01
#define	CT_ERROR					0x00
#define CT_DELETE_NONE				0x00
#define CT_DELETE_DATA				0x01
#define	CT_DELETE_HEADER			0x02
#define CT_DELETE_ALL				0x03

#define	MAX_SB						32			// Number of subbands
#define	MAX_SS						18			// Number of subband samples
#define MAX_CH						2			// Maximum number of channels
#define MAX_SIDEINFO_SIZE			38			// Maximum number bytes for side info

#define MPEG_MODE_STEREO			0x00		// Values of header.mode
#define MPEG_MODE_JOINT_STEREO		0x01
#define MPEG_MODE_DUAL_CHANNEL		0x02
#define MPEG_MODE_SINGLE_CHANNEL	0x03

#define MPEG_INTENSITY_STEREO		0x01		// Values of header.mode_extension
#define MPEG_MS_STEREO				0x02

#define MAX_FILENAME_SIZE			0x40

#define DECODER_MESSAGE_BASE			0x8000
#define DECODER_MESSAGE_PLAY			(DECODER_MESSAGE_BASE + 1)		
#define DECODER_MESSAGE_STOP			(DECODER_MESSAGE_BASE + 2)		
#define DECODER_MESSAGE_PAUSE			(DECODER_MESSAGE_BASE + 3)		
#define DECODER_MESSAGE_STATE			(DECODER_MESSAGE_BASE + 4)		
#define DECODER_MESSAGE_CODEC			(DECODER_MESSAGE_BASE + 5)		
#define DECODER_MESSAGE_GET_INFO		(DECODER_MESSAGE_BASE + 6)		
#define DECODER_MESSAGE_SET_VOLUME		(DECODER_MESSAGE_BASE + 7)		

#define OUTPUT_IOCTL_BASE				0x8100
#define OUTPUT_IOCTL_OPEN				(OUTPUT_IOCTL_BASE  + 1)		
#define OUTPUT_IOCTL_CLOSE				(OUTPUT_IOCTL_BASE  + 2)		
#define OUTPUT_IOCTL_NAME				(OUTPUT_IOCTL_BASE  + 3)		
#define OUTPUT_IOCTL_FLUSH				(OUTPUT_IOCTL_BASE  + 4)		
#define OUTPUT_IOCTL_SET_VOLUME			(OUTPUT_IOCTL_BASE  + 5)		

#define INPUT_IOCTL_BASE				0x8200
#define INPUT_IOCTL_OPEN				(INPUT_IOCTL_BASE   + 1)		
#define INPUT_IOCTL_CLOSE				(INPUT_IOCTL_BASE   + 2)		
#define INPUT_IOCTL_NAME				(INPUT_IOCTL_BASE   + 3)		
#define INPUT_IOCTL_REWIND				(INPUT_IOCTL_BASE   + 4)		
#define INPUT_IOCTL_GET_FILENAME		(INPUT_IOCTL_BASE   + 5)		
#define INPUT_IOCTL_GET_DURATION		(INPUT_IOCTL_BASE   + 6)		
#define INPUT_IOCTL_GET_SONG_NR			(INPUT_IOCTL_BASE   + 8)		
#define INPUT_IOCTL_GET_NR_OF_SONGS		(INPUT_IOCTL_BASE   + 9)		

#define DECODER_STATE_PLAYING			0x01
#define DECODER_STATE_STOPPED			0x02
#define DECODER_STATE_PAUSED			0x03
#define DECODER_STATE_EOS				0x04

enum {
	CODEC_TYPE_MPEG,
	CODEC_TYPE_WAVE
};

enum {
	HEADER_TYPE_NONE,
	HEADER_TYPE_OUTPUT,
	HEADER_TYPE_MPEG1,
	HEADER_TYPE_MPEG2
};

extern const char* mode_names[4];

extern const char* mode_ext_names[4];

extern const unsigned int bitrate_table[16];

extern const unsigned int sampling_table[4];

extern const unsigned int pretab[22];

extern const unsigned short sfBandIndex_l[3][23];
extern const unsigned short sfBandIndex_s[3][23];
extern const char slen[2][16];
		
#endif
