#include <stdio.h>

#define DEBUG								// uncomment this line for debug values
#define samplesoutput 1					// 1 if store the decoded requentized samples into a file
#define samplesframe 1					// this number tells how many frames of PCM sample to skip when dumping into a file
																// set samplesframe to 0 for normal operation

#ifdef DEBUG
 	#define DEBUG_ALIAS
// 	#define DEBUG_FRAMES
// 	#define DEBUG_HUFFMAN
 	#define DEBUG_IMDCT
// 	#define DEBUG_INVERSION
// 	#define DEBUG_MPEG
// 	#define DEBUG_REORDER
	#define DEBUG_REQUANTIZE
 	#define DEBUG_STEREO
 	#define DEBUG_SUBSYN
#endif

#define MEM_PATH "output_samples/memory_data"

#define STOP_PER_FRAME 0

#ifdef DEBUG
	#define OUTPUT_FILE_TYPE "a"
#else
	#define OUTPUT_FILE_TYPE "w"
#endif

#define INIT_OUTPUT_FILE_TYPE "w"

#define DATA_WIDTH 16
#define NEW_CODE 1							// 1 if using the code that Henry developed
#define NEW_TRUNCATE 0 					// 1 if truncate after mult and accumulations
#define NEW_TRANSLATE 0 				// 1 if round up the fix-point value
#define NEW_MULT 0							// 0: original mult, 1 with overflow detection
#define NEW_IMDCT 1							// 1 if using the faster IMDCT
#define NEW_MDCT 1							// 0 wut we have in hardware, 1 correct long mdct, 2 fast mdct, 3 long nicola mdct
#define NEW_STEREO 1						// 1 if using the adjusted stereo decoding
#define NEW_POLYPHASE 0					// 1 if using the adjusted polyphase for requantization adjustment

// REQUANTIZER BEGIN
#define ADJUST_EXP 0    // 1 if exp + 3
#define SEPARATE_SIGN 1 // 1 if separate sign bit in requantizer
#define LSB3_ADD 1      // 1 if adding is_val LSB3 to is ROM output
#define UNSIGNED_REQ 0  // 1 if using unsigned multiplication in requantizer (unstable!!)

#if DATA_WIDTH == 32
  #define ADJUST_EXP 0
  #define SEPARATE_SIGN 0
  #define UNSIGNED_REQ 0
  #define LSB3_ADD 0  // 32-bit not support yet!
#endif

#if LSB3_ADD == 1
  #define SEPARATE_SIGN 1
#endif

#if UNSIGNED_REQ == 1
  #define SEPARATE_SIGN 1
#endif
// REQUANTIZER END

// #define GEN_MEM
// #define GEN_ETHERNET
#define ETHERNET_COMMENT 0
#define GEN_TYPE 4 							// 0: Alias, 1: IMDCT, 2: SUBSYN, 3: AC97, 4: requantizer input
#define RANDOM_GEN 0
#define START_BLOCK 0
#define TARGET_CHANNEL 0
#define STEREO 1
#define NEWDATA 1
#define GEN_MIXED_BLOCK 0
#define WAVE_OUT 1

#define NUM_MEM 1648
#if GEN_TYPE == 0
#define NUM_SAMPLE 1024
#else
#define NUM_SAMPLE 576
#endif
#define MEM_COUNTER_WIDTH 11

#if DATA_WIDTH == 32
#define MASK 0xFFFFFFFF
#else
#define MASK 0x0000FFFF
#endif

#define TARGET_FILE "spot1"
// 0: Pure MS, normal
// 1: Pure MS, short
// 2: Pure IS, normal
// 3: Pure IS, short
// 4: MS+IS, normal
// 5: MS+IS, short
#define TARGET_TEST_CASE 5
// #define START_MEM TARGET_TEST_CASE*2
#define START_MEM 0
#define START_FRAME 1

unsigned int frame_count;
unsigned int gr_count;
unsigned int ch_count;
int mem_count;
FILE *temp_fp, *eth_left_fp, *eth_right_fp, *eth_fp;
int mixed_block_type_count;
int is_count, ms_count;
int average_ms_limit;
int average_rnsample;
int average_lnsample;
int average_cbmax;
FILE *left_data, *right_data;
int last_frame;
int match_criteria;
int test_case;
int start_frame_num;


