#ifndef __FILEOUTPUT_H__
#define __FILEOUTPUT_H__

#include "../decoder.h"

/* Wave Type Definitions */
// 1380533830, 1718449184, 1684108385, 1463899717
// #define R_TYPE 1380533830L
//  'RIFF'
// #define WAVE 1718449184L
//  'WAVE'
// #define F_TYPE 1684108385
//  'fmt '
// #define D_TYPE 1463899717
//  'data'
/* Wave Type Definitions for Mac */
#define R_TYPE 'RIFF'
#define WAVE 'WAVE'
#define F_TYPE 'fmt '
#define D_TYPE 'data'

typedef char ID[4];

typedef struct {
  ID type;
  unsigned int length;
  ID file_type;
}riff_chunk_t;

typedef struct {
  ID type;
  unsigned int length;
  unsigned int mode;
  unsigned int rate;
  unsigned int bps;
  unsigned short bytes_per_sam;
  unsigned short bits_per_sam;
}format_chunk_t;

typedef struct{
  ID type;
  unsigned int length;
}data_chunk_t;

typedef struct{
  short           numChannels;
  unsigned long   numSampleFrames;
  short           sampleSize;
  unsigned long   sampleRate;
} wav_data_t;

int file_output_register(CT_OutputModule *output_module);

#endif
