// -------------------------------------------------------
//
// Author: Thomas Lenart    
// Email:  thomas.lenart@es.lth.se
// Date:   March 2003
//
// -------------------------------------------------------

#include "wave.h"
#include "memhandler.h"
#include "buffer.h"
#include "mpeg.h"
#include "constants.h"

int wave_stream_decode(CT_Decoder *decoder)
{
	CT_Element		*input_element;
	CT_OutputHeader	*header;
	
	while (!buffer_empty(decoder->input_buffer)) {											// while not empty
		input_element = decoder->input_buffer->first;										// get the first item

		header = (CT_OutputHeader*)malloc(sizeof(CT_OutputHeader));					// allocate a new output buffer

		header->bytes_per_sample = 2;
		header->frequency = 44100;
		header->num_channels = 2;
		header->num_samples = input_element->data_size / header->num_channels / header->bytes_per_sample;

		buffer_add(decoder->output_buffer, input_element->data, input_element->data_size, header, HEADER_TYPE_OUTPUT);	// add the new element to the output buffer

		buffer_delete(decoder->input_buffer, CT_DELETE_HEADER);								// delete only header, leave data
	}	
	
	return 1;
}
