// 
//  MAC_MP3: A Low Energy Implementation of an Audio Decoder
//
//  Copyright (C) 2007 McMaster University
// 
//==============================================================================
// 
// This file is part of MAC_MP3
// 
// MAC_MP3 is distributed in the hope that it will be useful for further research,
// but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. MAC_MP3 is free; you can redistribute it
// and/or modify it provided that proper reference is provided to the authors. See
// the documents included in the "doc" folder for further details.
//
//==============================================================================

#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
using namespace std;

int main(int argc, char **argv)
{
  ifstream fp_in;
  ifstream FP_IN;
  fp_in.open(argv[1], ios::in);
  string r;
  //cout << "argc = " << argc << endl;
  if (argc == 1)
  {
    cout << "Usage: srom [sourcefile] [instantname]" << endl;
    return 1;
  }
  if (argc > 2)
    r = argv[2];
  else
    r = "romblock";
  
  string s;
  int c = 0;
  
  while (fp_in >> s)
  {
    cout << "// synthesis attribute INIT_" << uppercase << hex << setw(2) << setfill('0') << (c % 64) << " of " << r << (int)(c / 64) << " is \"256'h" << s << "\"" << endl;
    c++;
  }
  cout << "// synthesis translate_off" << endl;

  //fp_in.close();
  FP_IN.open(argv[1], ios::in);
  
  c = 0;
  while (FP_IN >> s)
  {
    cout << "defparam " << r << (int)(c / 64) << ".INIT_" << uppercase << hex << setw(2) << setfill('0') << (c % 64) << " = 256'h" << s << ";" << endl;
    c++;
  }
  cout << "// synthesis translate_on" << endl;

  FP_IN.close();
  return 0;
}
